mob/var/ClanLeader

var/guilds=new/list()
mob/var/guild=""
mob/var/invitable=0
mob/verb
	List_Guilds()
		set category="Guild"
		if("GM" in guilds)
			sleep(1)
		else
			var/savefile/C = new ("Guilds.sav")
			C["guilds"] >> guilds
			if("GM" in guilds)
				sleep(1)
			else
				guilds=new/list()
				guilds+="GM"
		usr<<"<b>Guilds:"
		var/online=0
		for(var/T in guilds)
			for(var/mob/M in world)
				if(M.guild==T)
					online+=1
			usr<<"[T] - Members Online:[online]"
			online=0
		var/savefile/X = new ("Guilds.sav")
		X["guilds"] << guilds
mob/verb
	Create_Guild()
		set category="Guild"
		if(usr.guild=="")
			if(usr.zenni>=100000)
				if("GM" in guilds)
					sleep(1)
				else
					var/savefile/C = new ("Guilds.sav")
					C["guilds"] >> guilds
					if("GM" in guilds)
						sleep(1)
					else
						guilds=new/list()
						guilds+="GM"
				var/newguild=input("What is the name of your new guild","Create Guild","[usr.name]'s Guild")as text
				switch(alert(usr,"Create [newguild]?","Guild Notice","Yes","No"))
					if("Yes")
						for(var/T in guilds)
							if(newguild==T)
								alert(usr,"Sorry that name is already taken","Guild Notice","Darn")
								return
						usr.guild=newguild
						usr.oocname=usr.guild
						usr.verbs += /mob/Leader/verb/MakeGuildItem
						usr.verbs += /mob/Leader/verb/Boot
						usr.verbs += /mob/verb/Guild_War
						usr.verbs -= /mob/verb/Create_Guild
						usr.invitable=1
						guilds+=newguild
						usr.ClanLeader =1
						var/savefile/X = new ("Guilds.sav")
						X["guilds"] << guilds
						usr.client.SaveMob()
						usr.zenni-=500
						alert(usr,"Successful Guild Creation!","Guild Notice","Done")
						return
			else
				usr<<"It costs 100k zenni to create a guild!"
		else
			usr<<"Youre already in a guild"

	Leave_Guild()
		set category="Guild"
		if(usr.guild=="")
			alert(usr,"You arent in a guild","Guild Notice","Oh")
		else
			switch(alert(usr,"Leave [usr.guild]?","Leave Guild","Yes","No"))
				if("Yes")
					if(usr.invitable==1)
						if(usr.guild=="GM")
							usr<<"The GM guild must stay on the Guild List!!"
						else
							guilds-=usr.guild
							usr.verbs -= /mob/Leader/verb/MakeGuildItem
							usr.verbs -= /mob/Leader/verb/Boot
							usr.verbs -= /mob/verb/Guild_War
							alert(usr,"Guild Removed From List","Remove Guild","OK")
					usr.guild=""
					usr.oocname = "Player"
					usr.invitable=0
					usr.ClanLeader=0
					alert(usr,"Guild Left!","Leave Guild","OK")
					usr.client.SaveMob()
					var/savefile/X = new ("Guilds.sav")
					X["guilds"] << guilds
	Invite(var/mob/M in world)
		set category="Guild"
		if(M.key)
			if(usr.invitable==1||usr.ClanLeader ==1)
				if(M.guild=="")
					usr<<"invite sent to [M]"
					switch(alert(M,"[usr] has invited you to join [usr.guild]","Guild Invite","Join","Decline"))
						if("Join")
							M.guild=usr.guild
							M.oocname=usr.guild
							M.verbs -= /mob/verb/Guild_War
							M.verbs -= /mob/verb/Create_Guild
							alert(usr,"[M] has joined your guild","Guild Notice","OK")
						if("Decline")
							alert(usr,"[M] declined your invite","Guild Notice","Darn")
				else
					usr<<"[M] is already in [M.guild]"
					M<<"[usr] tried to invite you to join [usr.guild] but you are already in [M.guild]"
			else
				usr<<"You dont have authorization to use this command"
				usr<<"This command is reserved for Guild Leaders"
		else
			usr<<"You cant invite NPCs to join your guild!"
	Guild_Chat(t as text)
		set category="Guild"
		if(usr.guild=="")
			usr<<"You arent in a guild!"
		else
			for(var/mob/M in world)
				if(M.guild==usr.guild)
					t=copytext(t,1,500)
					M<<"<b>[usr]-=[usr.guild]=-:</b> [html_encode(t)]"
mob/Leader
	verb
		MakeGuildItem()
			set name = "Make Guild Item"
			set category="Guild"
			var/iname = input("What should the name be?") as text
			var/iicon = input("What should the icon be?") as icon
			var/number=input("How many do you wish to make?") as num
			var/cost = number * 15000
			if(usr.zenni >= cost)
				usr.zenni -= cost
				while(number > 0)
					var/obj/wear/guild/GuildWear/G=new(usr)
					G.name = iname
					G.iguild="[usr.guild]"
					G.icon = iicon
					number -= 1
			else
				var/missing = cost - usr.zenni
				usr << "You need [missing] more zenni to make [number] of [iname]."
		Boot(var/mob/M in world)
			set category="Guild"
			switch(alert(usr,"Leave [usr.guild]?","Leave Guild","Yes","No"))
				if("Yes")
					if(usr.invitable==1)
						alert(M,"You have beeen booted from your guild","Guild Boot","OK")
						M.guild=""
						M.oocname = "Player"
						M.invitable=0
						usr.client.SaveMob()
mob
	verb
		Guild_War(var/mob/M in world)
			set category="Guild"
			if(usr.guild == "")
				usr << "Sorry, your not in a guild."
				return
			if(usr.ClanLeader == 0)
				usr << "Your Not Leader Of This Guild"
				return
			else
				switch(alert(M,"[usr] challenges your Guild to a fight.  Do you accept the request?","**Guild Challange**","Yes","No"))
					if("Yes")
						if(M.guild == usr.guild)
							alert("[src] accepted the Challenge","**Guild Challange Accepted**")
							M.loc =locate(41,12,2)
							usr.loc =locate(41,12,2)
						if(M.guild == src.guild)
							M.loc =locate(41,12,2)
							usr.loc =locate(41,12,2)

					if("No")
						alert(usr,"[M] declined the Challenge","**Guild Challange Declined**")




