/*
mob
	icon = 'Mob.dmi'
	icon_state = "BODY"
	Login()
		src.loc = locate(1,1,1) //Set the loc.  DO NOT REMOVE THIS.  There is a bug that will call Move() infinitely and nonsensically, generating errors.  Try it an you'll see.
		overlays += /obj/Head //This will be the visual for the head.  Because it's an overlay, it will never become out of sync
		I.tag = "[src.ckey]Head" //Tags can be used to quickly locate an atom.
	Move(turf/N,D) //We need the direction before we can move the head.
		if(!N) return //This would cause errors if we moved into null space, so we have to keep us from doing that.
		var/obj/Head = locate("[src.ckey]Head") //This is how you locate an object with a tag.
		if(Head.Move(locate(N.x,N.y+1,N.z),D)) //If the head can move there... note that when using a proc in an if() statement, the proc is run.
			..() //Then move us along!  Since the head already moved, we won't bump into it.
		return //If not, then nothing happens.
		*/

mob/var/oozaru

mob/var/ooztime

turf
	moonpad
		icon = 'moon.dmi'
		icon_state = ""
		density = 0
		verb
			Look()
				set category = "Moon"
				set name = "Look"
				if(usr.race == "Saiya-jin"||usr.race == "Halfbreed")
					if(usr.ooztime == 1)
						usr <<"You need to wait a little while before you will be able to turn into an Oozaru again!"
					else
						usr <<"You look at the Full Moon......you start to tingle...."
						usr.verbs += new /obj/OozaruTrans/verb/Oozaru
				else
					usr <<"The full moon is out..."
					world <<"<font color=blue><b>[usr] Looks ate the Full Moon and ...begins to turn into Oozaru!"

turf
	moonpd
		icon = 'moon.dmi'
		icon_state = ""
		density = 0
		verb
			Look()
				set category = "Moon"
				set name = "Look"
				if(usr.race == "Saiya-jin"||usr.race == "Halfbreed")
					if(usr.ooztime == 1)
						usr <<"You need to wait a little while before you will be able to turn into an Oozaru again!"
					else
						usr <<"You look at the Full Moon......you start to tingle...."
						usr.verbs += new /obj/OozaruTrans/verb/Oozaru
				else
					usr <<"The full moon is out..."
					world <<"<font color=blue><b>[usr] Looks ate the Full Moon and ...begins to turn into Oozaru!"














































obj
	OozaruTrans
		verb
			Oozaru()
				set category = "Oozaru"
				usr.overlays = 0
				if(usr.maxpowerlevel >= 65000000)
					usr.icon = 'GOozaru2.dmi'
					usr.icon_state = ""
					usr.overlays += /obj/GHead
					usr.oozaru = 1
					usr.powerlevel *= 10
					view(6) << "[usr] has become a Golden Oozaru!!"
					usr.verbs -= /obj/OozaruTrans/verb/Oozaru
					sleep(1900)
					usr << "Golden Oozaru is about to fade away!!"
					sleep(100)
					usr.powerlevel = usr.maxpowerlevel
					usr << "You felt your body try to contain the power but...it couldn't."
					usr.Oozaru2()
				else
					usr.icon = 'Oozaru.dmi'
					usr.icon_state = ""
					usr.overlays += /obj/Head
					usr.oozaru = 1
					usr.powerlevel *= 5
					view(6) << "[usr] has become an Oozaru!!"
					usr.verbs -= /obj/OozaruTrans/verb/Oozaru
					sleep(1900)
					usr << "Oozaru is about to fade away!!"
					sleep(100)
					usr.powerlevel = usr.maxpowerlevel
					usr.Oozaru2()



mob
	proc
		Oozaru2()
			if(usr.oozaru == 1)
				usr.oozaru = 0
				usr.powerlevel = usr.maxpowerlevel
				usr.icon = usr.oicon
				usr.icon_state = ""
				usr.overlays -= /obj/Head
				usr.overlays -= /obj/GHead
				usr.ooztime = 1
				if (usr.hair=="Spikey")
					var/hairover = 'hair_black_spikey.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="long")
					var/hairover = 'hair_black_long.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="Short")
					var/hairover = 'hair_black_short.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="Vegeta")
					var/hairover = 'hair_vegeta.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="Goku")
					var/hairover = 'hair_goku.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="Gohan")
					var/hairover = 'hair_Gohan.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="Trunks(Short)")
					var/hairover = 'hair_trunks2.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays -= hairover
				if (usr.hair=="Trunks(Long)")
					var/hairover = 'hair_trunks.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays -= hairover
				if (usr.hair=="Vegito")
					var/hairover = 'hair_vegito.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="K'ros")
					var/hairover = 'hair_kros.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				if (usr.hair=="K'ros(Long)")
					var/hairover = 'hair_kros_long.dmi'
					hairover += rgb(rhair,ghair,bhair)
					usr.overlays += hairover
				sleep(3000)
				usr.ooztime = 0





obj/Head //And this will be for the overlay.
	icon = 'Oozaru2.dmi'
	icon_state = ""
	pixel_y = 32 //So that the overlay appear above you.
	layer = 5
obj/GHead //And this will be for the overlay.
	icon = 'GOozaru.dmi'
	icon_state = ""
	pixel_y = 32 //So that the overlay appear above you.
	layer = 5