#define HOUR	36000 //Defines an hour in ticks

world/New() //	When the world starts
    ..()
    spawn() DAYNIGHT() //	Lets call the daynight proc

proc/DAYNIGHT()	//	Name of the proc
	while(world)	//	If the world is still up and running
		sleep(HOUR)	//	Remember how we defined HOUR? This is where it comes into place
		var/obj/Night/O = new /obj/Night //	Define the "NIGHT" object that will make the area night.
		world<<"<b><font color=red>Night falls over the land.</b></font>"	//	Display to the world its night time!
		for(var/turf/T in world)	//This is for all the turfs
			T.overlays+= O	//	See the line above? This adds all the overlays of "Night" to the turfs in the world
			if(istype(T,/turf/grayfloor))T.overlays-= O
		for(var/area/A in world)	//This is for all the turfs
			A.overlays+= O	//	See the line above? This adds all the overlays of "Night" to the turfs in the world
			if(istype(A,/area/house))A.overlays-= O
		for(var/mob/M in world)
			M << "You see the MOON!!!"
			M.verbs += /obj/OozaruTrans/verb/Oozaru
		sleep(HOUR)	// Heres another hour passing by!
		for(var/turf/T in world)	//This is for all the turfs
			T.overlays-= O	//This removes all of the night overlays from all the turfs
		for(var/mob/M in world)
			M << "The moon disapears from sight!!!"
			M.verbs -= /obj/OozaruTrans/verb/Oozaru
		world<<"<b><font color=red>The evening sun rises.</b></font>"	//Display that its morning!

obj/Night
	icon='black50.dmi'
	icon_state=""
	layer = MOB_LAYER+52	//	Display the night over the player

obj/Rain
	icon='rain.dmi'
	icon_state=""
	layer = MOB_LAYER+52	//	Display the night over the player

obj/Snow
	icon='snow.dmi'
	icon_state=""
	layer = MOB_LAYER+52	//	Display the night over the player



//	Don't want to make the night/day automiatic? Thats good, because here you can control it yourself!

