#define ICON_NAME 'bubbles.dmi'

mob
	var
		obj/s_bubble/s_bubble
	proc
		BubbleTalk(duration = 30)
			src.BubbleCustom(ICON_NAME,"talk",duration)

		BubbleHappy(duration = 10)
			src.BubbleCustom(ICON_NAME,"happy",duration)

		BubbleAngry(duration = 10)
			src.BubbleCustom(ICON_NAME,"anger",duration)

		BubbleSigh(duration = 10)
			src.BubbleCustom(ICON_NAME,"sigh",duration)

		BubbleX(duration = 10)
			src.BubbleCustom(ICON_NAME,"X",duration)

		BubbleO(duration = 10)
			src.BubbleCustom(ICON_NAME,"O",duration)

		BubbleSad(duration = 10)
			src.BubbleCustom(ICON_NAME,"sad",duration)

		BubbleFrown(duration = 10)
			src.BubbleCustom(ICON_NAME,"mad",duration)

		BubbleExclaim(duration = 10)
			src.BubbleCustom(ICON_NAME,"!",duration)

		BubbleQuery(duration = 10)
			src.BubbleCustom(ICON_NAME,"?",duration)

		BubbleLove(duration = 10)
			src.BubbleCustom(ICON_NAME,"love",duration)

		BubbleIdea(duration = 10)
			src.BubbleCustom(ICON_NAME,"idea",duration)

		BubbleSing(duration = 10)
			src.BubbleCustom(ICON_NAME,"sing",duration)

		BubbleGrin(duration = 10)
			src.BubbleCustom(ICON_NAME,"grin",duration)

		BubbleTongue(duration = 10)
			src.BubbleCustom(ICON_NAME,"tongue",duration)

		BubbleLaugh(duration = 10)
			src.BubbleCustom(ICON_NAME,"laugh",duration)

		BubbleWink(duration = 10)
			src.BubbleCustom(ICON_NAME,"wink",duration)

		BubbleCustom(icon as icon,icon_state as text,duration = 10)
			del(src.s_bubble)
			src.s_bubble = new
			spawn() src.s_bubble.Display(src,icon,icon_state,duration)

obj/s_bubble/proc/Display(mob/M,icon,icon_state,duration)
	src.layer = 6
	var/turf/T = locate(M.x,M.y+1,M.z)
	if(T)
		src.loc = T
	else
		src.loc = M.loc
	src.icon = icon
	flick("popup",src)
	sleep(2)
	src.icon_state = icon_state
	sleep(duration)
	flick("popdown",src)
	sleep(2)
	del(src)

mob/Move()
	. = ..()
	if(src.s_bubble)
		var/turf/T = locate(src.x,src.y+1,src.z)
		if(T)
			src.s_bubble.loc = T
		else
			src.s_bubble.loc = src.loc
	return

obj/Hud
	var/num = 0
	var/width = 100
	var/rangemax
	var/rangemin

	Save_Button

		name = "Save"
		layer = 999
		icon = 'icons1.dmi'
		icon_state = "save"
		screen_loc = "13,13"
		Click()
			usr << "<B><I><font color = yellow>You game data has been saved!"
			usr.client.SaveMob()


	EXP
		layer = MOB_LAYER+2  // Sets it at a layer above the background.

		exptitle
			icon = 'EXP Meter.dmi'
			screen_loc = "1,10"

		meter1
			icon = 'meter3.dmi'
			icon_state = "0"
			screen_loc = "1,5"
			rangemax = 19
			rangemin = 0

		meter2
			icon = 'meterm3.dmi'
			icon_state = "0"
			screen_loc = "1,6"
			rangemax = 39
			rangemin = 20

		meter3
			icon = 'meterm3.dmi'
			icon_state = "0"
			screen_loc = "1,7"
			rangemax = 59
			rangemin = 40

		meter4
			icon = 'meterm3.dmi'
			icon_state = "0"
			screen_loc = "1,8"
			rangemax = 79
			rangemin = 60

		meter5
			icon = 'metert3.dmi'
			icon_state = "0"
			screen_loc = "1,9"
			rangemax = 99
			rangemin = 80


mob

	proc/Update()                                  // Compares the percentage of the
		for(var/obj/Hud/EXP/O in src.client.screen)     // src's health with the range of
			O.num = round((src.exp/src.maxexp)*O.width)// each objects, then sets icon
			if(O.num >= O.rangemax)                // state accordingly
				O.icon_state = "19"
			if(O.num <= O.rangemin)
				O.icon_state = "0"
			if(O.num < O.rangemax && O.num > O.rangemin)
				var/newnum = O.num - O.rangemin
				O.icon_state = "[newnum]"
mob/var/obj/Hud
	Save_Button/Save_Button=new
mob/var/obj/Hud/EXP
	meter1/meter1 = new
	meter2/meter2 = new
	meter3/meter3 = new
	meter4/meter4 = new
	meter5/meter5 = new
	exptitle/exptitle = new


mob/proc
	HudAdd()
		usr.client.screen+=Save_Button
		usr.client.screen+=meter1
		usr.client.screen+=meter2
		usr.client.screen+=meter3
		usr.client.screen+=meter4
		usr.client.screen+=meter5
		usr.client.screen+=exptitle

mob
	proc
		Auto_Save()
			src.client.SaveMob()
			spawn(1200) src.Auto_Save()



var
	const//Some nice and lengthy mathematical constants.  BYOND rounds them off, but I like to have 'em handy anyway.
		pi =	3.1415926535897932384626433832795
		sqrt2 =	1.4142135623730950488016887242097	//Square root of 2
		e =		2.7182818284590452353602874713527


proc
	xrange(atom/center, range)
		var/startx = center.x - range
		var/starty = center.y - range
		var/endx = center.x + range
		var/endy = center.y + range
		if(startx < 1) startx = 1
		if(starty < 1) starty = 1
		if(endx > world.maxx) endx = world.maxx
		if(endy > world.maxy) endy=world.maxy
		var/contents[] = list()
		for(var/turf/T in block(locate(startx, starty, center.z), locate(endx, endy, center.z)))
			contents += T
			contents += T.contents
		return contents

	get_steps(atom/ref,dir,num)
		var/x
		var/turf/T=ref:loc
		if(isturf(ref))
			T=ref
		for(x=0;x<num;x++)
			ref=get_step(ref,dir)
			if(!ref)break
			T=ref
		return T

	allclear(turf/T)
		if(isturf(T))
			if(T.density) return 0
		var/mob/M
		for(M as mob|obj in T)
			if(M.density)
				return 0
		return 1

	cardinal(atom/ref)
		return (list(get_step(ref,NORTH),get_step(ref,SOUTH),get_step(ref,EAST),get_step(ref,WEST)))

	cardinal_stuff(atom/ref)
		var/turfs[]=list(get_step(ref,NORTH),get_step(ref,SOUTH),get_step(ref,EAST),get_step(ref,WEST))
		var/stuff[]=list()
		var/turf/T
		for(T in turfs)
			stuff+=T.contents
		return stuff

	midpoint(atom/M,atom/N)
		var/turf/T = locate((N.x + M.x)/2, (N.y + M.y)/2, (N.z + M.z)/2)
		return T

	distance(atom/M,atom/N)
		return sqrt((N.x-M.x)**2 + (N.y-M.y)**2)

	getring(atom/M, radius)
		var/ring[] = list()
		var/turf/T
		for(T as turf in range(radius+1,M))
			if(abs(distance(T, M)-radius) < 0.5)//The < 0.5 check is to make sure the ring is smooth
				ring += T
		return ring

	getcircle(atom/M, radius)
		var/list/circle = list()
		var/turf/T
		for(T as turf in range(radius+3,M))		//The < 0.5 check is to ensure it has the same shape as
			if(distance(T, M) < radius + 0.5) 	//a get_ring() of the same radius
				circle += T
		return circle

	sign(x) //Should get bonus points for being the most compact code in the world!
		return ((x<0)?-1:((x>0)?1:0))

	getline(atom/M,atom/N)//Ultra-Fast Bresenham Line-Drawing Algorithm
		var/px=M.x		//starting x
		var/py=M.y
		var/line[] = list(locate(px,py,M.z))
		var/dx=N.x-px	//x distance
		var/dy=N.y-py
		var/dxabs=abs(dx)//Absolute value of x distance
		var/dyabs=abs(dy)
		var/sdx=sign(dx)	//Sign of x distance (+ or -)
		var/sdy=sign(dy)
		var/x=dxabs>>1	//Counters for steps taken, setting to distance/2
		var/y=dyabs>>1	//Bit-shifting makes me l33t.  It also makes getline() unnessecarrily fast.
		var/j			//Generic integer for counting
		if(dxabs>=dyabs)	//x distance is greater than y
			for(j=0;j<dxabs;j++)//It'll take dxabs steps to get there
				y+=dyabs
				if(y>=dxabs)	//Every dyabs steps, step once in y direction
					y-=dxabs
					py+=sdy
				px+=sdx		//Step on in x direction
				line+=locate(px,py,M.z)//Add the turf to the list
		else
			for(j=0;j<dyabs;j++)
				x+=dxabs
				if(x>=dyabs)
					x-=dyabs
					px+=sdx
				py+=sdy
				line+=locate(px,py,M.z)
		return line



