mob/Login()
	for(var/mob/M in world)
		if(M.name==src.key)
			if(M.key)
				sleep(1)
			else
				del M

	CheckBan(src)
	src.loc=locate(7,7,1)
	src.move = 1
	src.ko = 0
	src.blocking = 0
	src.ptime = 0
	src.kiin = 0
	src.grav = 0
	src.combo = 0
	src.angered = 0
	src.powerlevel = src.maxpowerlevel
	src.tech = 0
	src.gainzenni = 0
	src.slap = 0
	src.entime = 0
	src.sight = 0
	src.focused = 0
	src.spar = 0
	usr.style = 'style-calming.dmi'
	usr.stylename = "Kame"
	src.icon_state = ""
	src.ased = 0
	src.plarper = 1
	src.absorb = 0
	src.flight = 0
	src.tayio = 0
	src.training = 0
	src.density = 1
	src.safe = 0
	src.meditate = 0
	src.medtime = 0
	src.talk = 1
	if(usr.key in players)
		usr.loc=locate(usr.lastx,usr.lasty,usr.lastz)
		world<<"<b>[src] the <font color=blue>[src.race]</font> has entered the world!</font>"
	else
		usr<<browse(trans)
		usr<<browse(help,"window=Help,size=500x500")
		players+=usr.key
		usr<<sound('titlesong.mid')
		world << "<b><font color = white>[src] has arrived!</font>"

mob/verb/Help()
	set category="Communication"
	usr<<browse(help,"window=Help,size=500x500")


mob/verb/checkplayers()
	set hidden=1
	usr<<"<b>Keys in list"
	for(var/t in players)
		usr<<"[t]"
mob/Logout()
	for(var/mob/M in world)
		if(M.key==usr.key)
			return
		else
			world << "<b><font color = white>[src] has left this world!</font>"
			players-=usr.key
			del(src)

mob/var/lastx
mob/var/lasty
mob/var/lastz
var/players=new/list()

client/proc/SaveMob()
	usr.lastx=usr.x
	usr.lasty=usr.y
	usr.lastz=usr.z
	var/firstletter=copytext(src.ckey, 1, 2)
	var/savefile/F = new("players/[firstletter]/[src.ckey].sav")
	var/char_ckey = cKey(src.mob.name)
	F["/[ckey]/[char_ckey]"]<<src.mob
	src<<"Save Complete!"
	sleep(1)

client/proc/LoadMob(char_ckey)
	var/firstletter=copytext(src.ckey, 1, 2)
	var/savefile/F = new("players/[firstletter]/[src.ckey].sav")
	F["/[ckey]/[char_ckey]"]>>src.mob

	src<<"Load Successful"

turf
	startgame
		icon = 'startgame.bmp'
		icon_state="0,0"
		density = 1
		Click()
			switch(alert(usr,"Start game with these settings?","Start Game","Yes","No"))
				if("Yes")
					usr.loc=locate(73,72,2)
					usr.safe=2
					world<<"<b>[usr] the <font color=blue>[usr.race]</font> has joined the world!</font>"
	hairselect
		icon = 'hairselect.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.hairselect()
	titleselect
		icon = 'titleselect.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.titleselect()
	faceselect
		icon = 'faceselect.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.faceiconselect()
	styleselect
		icon = 'styleselect.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.styleselect()
	sideselect
		icon = 'sideselect.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.sideselect()
	newgame
		icon = 'newgame.bmp'
		icon_state="0,0"
		density = 1
		Click()
			usr.CreateNewCharacter()
	loadgame
		icon = 'loadgame.bmp'
		icon_state="0,0"
		density = 1
		Click()
			var/list/characters = usr.CharacterList()
			var/DeleteCharacterChoice = "Delete Character"
			var/Cancel = "Cancel"
			var/list/menu = new()
			menu += characters
			menu += Cancel
			var/result = input("Load/Delete Character", "DragonBall Z Saiyan Legacy") in menu
			if (result == DeleteCharacterChoice)
				menu += characters
			if(result==Cancel)
				alert("No Previously Saved Characters")
			else
				usr.client.LoadMob(result)

mob
	proc
		CharacterList()
			var/firstletter=copytext(src.ckey, 1, 2)
			var/savefile/F = new("players/[firstletter]/[src.ckey].sav")
			F.cd = "/[ckey]"
			var/list/characters = F.dir
			return characters


mob/proc/CreateNewCharacter()
	var/prompt_title = "Character Creation"
	var/help_text = "What is your name? "
	var/default_value = "[usr.key]"
	var/char_name = input(usr, help_text, prompt_title, default_value) as null|text

	var/ckey_name = ckey(char_name)
	var/list/characters = CharacterList()
	if (characters.Find(ckey_name))
		alert("Name Error?")
		usr.CreateNewCharacter()
		return

	help_text = "What is your race?"
	var/list/races = list("Saiyan", "Human", "Halfbreed", "Namekian", "Biological Android","Android", "Icer","Demon")
	default_value = "Saiya-jin"
	var/char_race = input(usr, help_text, prompt_title, default_value) in races
	switch(char_race)
		if("Demon")
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 800
			usr.dead = 0
			usr.maxpowerlevel = 800
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.kaioken = 0
			usr.rage = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.father = "Unknown"
			usr.zenni = 0
			usr.faceicon = 'default.dmi'
			usr.will = 0
			usr.honor = 0
			usr.gonessj = 0
			usr.state = "Normal"
			usr.purity = 0
			usr.talk = 1
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.auratechlearn = 0
			usr.bangtechlearn=0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.style = 'style-cosmic.dmi'
			usr.stylename = "Demon"
			usr.flightlearn = 0
			usr.race = "Demon"
			usr.title = ""
			switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("Red"))
				if("Red")
					usr.icon = 'demon.dmi'




		if("Human")
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 5
			usr.dead = 0
			usr.maxpowerlevel = 5
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.kaioken = 0
			usr.rage = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.father = "Unknown"
			usr.zenni = 0
			usr.faceicon = 'default.dmi'
			usr.will = 0
			usr.honor = 0
			usr.gonessj = 0
			usr.state = "Normal"
			usr.purity = 0
			usr.talk = 1
			usr.bangtechlearn =0
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.auratechlearn = 0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.race = "Earth-sei-jin"
			usr.title = ""
			switch(input("What is your gender?", "Character Creation", text) in list ("Male", "Female"))
				if("Male")
					switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("White", "Tan", "Dark Brown","Olive"))
						if("White")
							usr.icon = 'male-white.dmi'
						if("Tan")
							usr.icon = 'male.dmi'
						if("Dark Brown")
							usr.icon = 'male-black.dmi'
						if("Olive")
							usr.icon = 'male-olive.dmi'
				if("Female")
					usr.icon='female.dmi'

		if("Saiyan")
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 5
			usr.maxpowerlevel = 5
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.dead = 0
			usr.rage = 0
			usr.rage = 0
			usr.faceicon = 'default.dmi'
			usr.gonessj = 0
			usr.maxstamina = 100
			usr.zenni = 0
			usr.will = 0
			usr.honor = 0
			usr.gonessj = 0
			usr.state = "Normal"
			usr.purity = 0
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.bangtechlearn=0
			usr.auratechlearn = 0
			usr.kaioken = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.father = "Unknown"
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.race = "Saiya-jin"
			usr.overlays += /obj/tail
			new/obj/SayajinTail(usr)
			new/obj/tr(usr)
			usr.title = ""
			usr.talk = 1
			switch(input("What Gender do you want?", "Character Creation", text) in list ("Male", "Female"))
				if("Male")
					switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("White", "Tan", "Dark Brown","Olive"))
						if("White")
							usr.icon = 'male-white.dmi'
						if("Tan")
							usr.icon = 'male.dmi'
						if("Dark Brown")
							usr.icon = 'male-black.dmi'
						if("Olive")
							usr.icon = 'male-olive.dmi'
				if("Female")
					usr.icon='female.dmi'




		if("Halfbreed")
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 5
			usr.maxpowerlevel = 5
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.rage = 0
			usr.faceicon = 'default.dmi'
			usr.maxstamina = 100
			usr.zenni = 0
			usr.gonessj = 0
			usr.will = 0
			usr.honor = 0
			usr.state = "Normal"
			usr.gonessj = 0
			usr.purity = 0
			usr.dead = 0
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.bangtechlearn = 0
			usr.father = "Unknown"
			usr.kaioken = 0
			usr.auratechlearn = 0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.race = "Saiya-jin"
			new/obj/tr(usr)
			usr.title = ""
			usr.talk = 1
			switch(input("What Gender do you want?", "Character Creation", text) in list ("Male", "Female"))
				if("Male")
					switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("White", "Tan", "Dark Brown","Olive"))
						if("White")
							usr.icon = 'male-white.dmi'
						if("Tan")
							usr.icon = 'male.dmi'
						if("Dark Brown")
							usr.icon = 'male-black.dmi'
						if("Olive")
							usr.icon = 'male-olive.dmi'
				if("Female")
					usr.icon='female.dmi'



		if("Namekian")

			usr.icon = 'namek.dmi'
			usr.hair = "Bald"
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 5
			usr.maxpowerlevel = 5
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.rage = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.father = "Unknown"
			usr.maxstamina = 100
			usr.state = "Normal"
			usr.bangtechlearn=0
			usr.kaioken = 0
			usr.zenni = 0
			usr.will = 0
			usr.honor = 0
			usr.purity = 0
			usr.faceicon = 'default.dmi'
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.dead = 0
			usr.auratechlearn = 0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.title = ""
			usr.race = "Namek-jin"
			new/obj/tr(usr)
			usr.icon = 'namek.dmi'
			usr.talk = 1
			switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("Green", "Dark Green"))
				if("Green")
					usr.icon = 'namek.dmi'
				if("Dark Green")
					usr.icon = 'namek-dark.dmi'

		if("Biological Android")
			switch(input("What type?", "Bioandroid", text) in list ("Human Type","Custom Skin Human Type","Blue Dragon Type","Cell Type"))
				if("Cell Type")
					usr.icon = 'Cell.dmi'
					usr.move = 1
					usr.focused = 0
					usr.powerlevel = 1000
					usr.maxpowerlevel = 1000
					usr.punchstrength = rand(1,10)
					usr.kickstrength = rand(1,10)
					usr.defense=rand(1,10)
					usr.mother = "None"
					usr.father = "None"
					usr.rage = 0
					usr.kaioken = 0
					usr.rage = 0
					usr.state = "Normal"
					usr.bangtechlearn=0
					usr.maxstamina = 100
					usr.faceicon = 'default.dmi'
					usr.zenni = 0
					usr.will = 0
					usr.dead = 0
					usr.honor = 0
					usr.purity = 0
					usr.kitech = "None"
					usr.auratech = "None"
					usr.kitechlearn = 0
					usr.auratechlearn = 0
					usr.focustechlearn = 0
					usr.kicolor = "None"
					usr.focus = "None"
					usr.flightlearn = 0
					usr.title = ""
					usr.race = "Bio-Android"
					new/obj/tr(usr)
					usr.talk = 1
					new/obj/Absorb(usr)


				if("Human Type")
					usr.icon = 'male.dmi'
					usr.move = 1
					usr.focused = 0
					usr.powerlevel = 1000
					usr.maxpowerlevel = 1000
					usr.punchstrength = rand(1,10)
					usr.kickstrength = rand(1,10)
					usr.defense=rand(1,10)
					usr.rage = 0
					usr.rage = 0
					usr.bangtechlearn=0
					usr.maxstamina = 100
					usr.zenni = 0
					usr.faceicon = 'default.dmi'
					usr.state = "Normal"
					usr.will = 0
					usr.dead = 0
					usr.honor = 0
					usr.purity = 0
					usr.kaioken = 0
					usr.maxstamina = 100
					usr.mother = "None"
					usr.father = "None"
					usr.kitech = "None"
					usr.auratech = "None"
					usr.kitechlearn = 0
					usr.auratechlearn = 0
					usr.focustechlearn = 0
					usr.kicolor = "None"
					usr.focus = "None"
					usr.flightlearn = 0
					usr.title = ""
					usr.race = "Biological Android"
					new/obj/tr(usr)
					usr.talk = 1
					switch(input("What Gender do you want?", "Character Creation", text) in list ("Male", "Female"))
						if("Male")
							switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("White", "Tan", "Dark Brown","Olive"))
								if("White")
									usr.icon = 'male-white.dmi'
								if("Tan")
									usr.icon = 'male.dmi'
								if("Dark Brown")
									usr.icon = 'male-black.dmi'
								if("Olive")
									usr.icon = 'male-olive.dmi'
						if("Female")
							usr.icon='female.dmi'



				if("Custom Skin Human Type")
					usr.icon = 'bioandroid-two.dmi'
					usr.move = 1
					usr.focused = 0
					usr.powerlevel = 1000
					usr.maxpowerlevel = 1000
					usr.punchstrength = rand(1,10)
					usr.kickstrength = rand(1,10)
					usr.defense=rand(1,10)
					usr.rage = 0
					usr.rage = 0
					usr.maxstamina = 100
					usr.zenni = 0
					usr.will = 0
					usr.faceicon = 'default.dmi'
					usr.dead = 0
					usr.state = "Normal"
					usr.kaioken = 0
					usr.honor = 0
					usr.purity = 0
					usr.bangtechlearn=0
					usr.kitech = "None"
					usr.auratech = "None"
					usr.kitechlearn = 0
					usr.auratechlearn = 0
					usr.mother = "None"
					usr.father = "None"
					usr.focustechlearn = 0
					usr.kicolor = "None"
					usr.focus = "None"
					usr.flightlearn = 0
					usr.title = ""
					usr.race = "Biological Android"
					new/obj/tr(usr)
					usr.talk = 1
					switch(input("Do you want to customize your skin color?", "Character Creation", text) in list ("Yes", "No"))
						if("Yes")
							var/red = input("How much red (out of the RGB) do you want to put in your skin?| (0,0,0) = Black | (255,255,255) = White. |") as num|null
							usr.icon += rgb((red),0,0)
							var/blue = input("How much green (out of the RGB) do you want to put in your skin?| (0,0,0) = Black | (255,255,255) = White. |") as num|null
							usr.icon += rgb(0,(blue),0)
							var/green = input("How much blue (out of the RGB) do you want to put in your skin?| (0,0,0) = Black | (255,255,255) = White. |") as num|null
							usr.icon += rgb(0,0,(green))
						if("No")
							..()


				if("Blue Dragon Type")
					usr.icon = 'bioandroid-one.dmi'
					usr.move = 1
					usr.focused = 0
					usr.powerlevel = 1000
					usr.maxpowerlevel = 1000
					usr.punchstrength = rand(1,10)
					usr.kickstrength = rand(1,10)
					usr.defense=rand(1,10)
					usr.mother = "None"
					usr.father = "None"
					usr.rage = 0
					usr.kaioken = 0
					usr.rage = 0
					usr.state = "Normal"
					usr.bangtechlearn=0
					usr.maxstamina = 100
					usr.faceicon = 'default.dmi'
					usr.zenni = 0
					usr.will = 0
					usr.dead = 0
					usr.honor = 0
					usr.purity = 0
					usr.kitech = "None"
					usr.auratech = "None"
					usr.kitechlearn = 0
					usr.auratechlearn = 0
					usr.focustechlearn = 0
					usr.kicolor = "None"
					usr.focus = "None"
					usr.flightlearn = 0
					usr.title = ""
					usr.race = "Biological Android"
					new/obj/tr(usr)
					usr.talk = 1




		if("Android")
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 1000
			usr.maxpowerlevel = 1000
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.rage = 0
			usr.faceicon = 'default.dmi'
			usr.maxstamina = 100
			usr.zenni = 0
			usr.will = 0
			usr.dead = 0
			usr.state = "Normal"
			usr.kaioken = 0
			usr.mother = "None"
			usr.father = "None"
			usr.honor = 0
			usr.purity = 0
			usr.kitech = "None"
			usr.bangtechlearn=0
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.auratechlearn = 0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.title = ""
			usr.icon = 'bioandroid-two.dmi'
			usr.race = "Android"
			new/obj/tr(usr)
			usr.talk = 1
			switch(input("What Gender do you want?", "Character Creation", text) in list ("Male", "Female"))
				if("Male")
					switch(input("What tint of skin color do you want?", "Character Creation", text) in list ("White (Pale)", "Tan", "Dark Brown","Olive"))
						if("White (Pale)")
							usr.icon = 'male-white.dmi'
						if("Tan")
							usr.icon = 'male.dmi'
						if("Dark Brown")
							usr.icon = 'male-black.dmi'
						if("Olive")
							usr.icon = 'male-olive.dmi'
				if("Female")
					usr.icon='female.dmi'


		if("Icer")
			usr.icon = 'changling.dmi'
			usr.move = 1
			usr.focused = 0
			usr.powerlevel = 5
			usr.dead = 0
			usr.maxpowerlevel = 5
			usr.punchstrength = rand(1,10)
			usr.kickstrength = rand(1,10)
			usr.defense=rand(1,10)
			usr.rage = 0
			usr.kaioken = 0
			usr.rage = 0
			usr.maxstamina = 100
			usr.mother = "Unknown"
			usr.father = "Unknown"
			usr.bangtechlearn=0
			usr.zenni = 0
			usr.faceicon = 'default.dmi'
			usr.will = 0
			usr.honor = 0
			usr.gonessj = 0
			usr.state = "Normal"
			usr.purity = 0
			usr.talk = 1
			usr.kitech = "None"
			usr.auratech = "None"
			usr.kitechlearn = 0
			usr.auratechlearn = 0
			usr.focustechlearn = 0
			usr.kicolor = "None"
			usr.focus = "None"
			usr.flightlearn = 0
			usr.race = "Icer"
			new/obj/tr(usr)
			usr.title = ""
			new/obj/icer_transform(usr)

	usr.oicon = usr.icon
	usr.npp = 0
	usr.name = char_name
	usr.loc=locate(21,7,1)
	for(var/obj/O in view(1,usr))
		if(O.name=="faceicondisplay")
			O.icon=usr.faceicon
	if(stylename=="Vegeta")
		usr.honor+=4
		usr.will+=2
	if(stylename=="Kame")
		usr.purity+=4
		usr.will+=2
	if(stylename=="Piccolo")
		usr.will+=4
		usr.honor+=2
	if(stylename=="Satan")
		stylename="Kame"
		usr.honor+=4
		usr.will+=2
	if(stylename=="Korin")
		stylename="Kame"
		usr.honor+=4
		usr.will+=2
	if(stylename=="Tien")
		usr.purity+=1
		usr.honor+=3
		usr.will+=2
	if(stylename=="Gohan")
		usr.will+=3
		usr.purity+=2
		usr.honor+=1
	if(stylename=="Krillin")
		usr.will+=3
		usr.purity+=3
	if(stylename=="Unknown")
		stylename="Kame"
		usr.honor+=4
		usr.will+=2
mob
	proc
		hairselect()
			usr.overlays=""
			switch(input("What kind of hair do you have?", "Hair", text) in list ("Long","Spikey","Dreadlocks","Short","Goku","Vegeta","Bald","Gohan","Vegito","Trunks"))

				if("Bald")
					switch(input("What kind of facial hair do you have?", "Facial Hair", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Bald"
				if("Gohan")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Gohan"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_Gohan.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover
				if("Dreadlocks")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Dreadlocks"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'dreadlocks.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover
				if("Vegito")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Vegito"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_vegito.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover
				if("Trunks")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Trunks"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_trunks.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover
				if("Short")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Short"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_black_short.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover




				if("Spikey")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Spikey"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_black_spikey.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover


				if("Long")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "long"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_black_long.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover

				if("Vegeta")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Vegeta"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_vegeta.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover

				if("Goku")
					switch(input("What kind of facial hair do you want?", "Customization", text) in list ("None","Goatee","Goat", "Mustache"))
						if("None")
							..()
						if("Goatee")
							usr.overlays += 'black_goatee.dmi'
							..()
						if("Goat")
							usr.overlays += 'black_goat.dmi'
							..()
						if("Mustache")
							usr.overlays += 'black_mustache.dmi'
							..()
					usr.hair = "Goku"
					var/hairred = input("How much red do you want to put into your hair?") as num
					var/hairblue = input("How much blue do you want to put into your hair?") as num
					var/hairgreen = input("How much green do you want to put into your hair?") as num
					var/hairover = 'hair_goku.dmi'
					hairover += rgb(hairred,hairgreen,hairblue)
					usr.rhair = hairred
					usr.ghair = hairgreen
					usr.bhair = hairblue
					usr.overlays += hairover

mob/proc/titleselect()
	switch(input("Do you want a title?","Character Creation",text) in list ("Yes","No"))
		if("Yes")
			var/amount = input("What do you want your title to be? (If you use HTML, end it with </font>).") as text|null
			usr.title = amount
		if("No")
			..()
mob/proc/styleselect()
	switch(alert("Changing this will reset your Will, Honor, and Purity","WARNING!!!","Continue","Cancel"))
		if("Continue")
			usr.honor=0
			usr.will=0
			usr.purity=0
			switch(input("What Fighting Style are you?","Character Creation",text) in list ("Kame","Piccolo","Vegeta","Tien","Gohan","Krillin"))
				if ("Kame")
					usr.style = 'style-calming.dmi'
					usr.stylename = "Kame"
				if ("Piccolo")
					usr.style = 'style-calming.dmi'
					usr.stylename = "Piccolo"
				if ("Vegeta")
					usr.style = 'style-blocking.dmi'
					usr.stylename = "Vegeta"
				if ("Tien")
					usr.style = 'style-blocking.dmi'
					usr.stylename = "Tien"
				if ("Gohan")
					usr.style = 'style-cosmic.dmi'
					usr.stylename = "Gohan"
				if ("Krillin")
					usr.style = 'style-cosmic.dmi'
					usr.stylename = "Krillin"
			if(stylename=="Vegeta")
				usr.honor+=4
				usr.will+=2
			if(stylename=="Kame")
				usr.purity+=4
				usr.will+=2
			if(stylename=="Piccolo")
				usr.will+=4
				usr.honor+=2
			if(stylename=="Satan")
				stylename="Kame"
				usr.honor+=4
				usr.will+=2
			if(stylename=="Korin")
				stylename="Kame"
				usr.honor+=4
				usr.will+=2
			if(stylename=="Tien")
				usr.purity+=1
				usr.honor+=3
				usr.will+=2
			if(stylename=="Gohan")
				usr.will+=3
				usr.purity+=2
				usr.honor+=1
			if(stylename=="Krillin")
				usr.will+=3
				usr.purity+=3
			if(stylename=="Unknown")
				stylename="Kame"
				usr.honor+=4
				usr.will+=2
mob/proc/faceiconselect()
	switch(input("Do you want a face icon?", "Face Icon",text) in list("Yes","No"))
		if("Yes")
			var/class = input("What kind of face icon?","Icon Choose") in list("Icon","Preset Icon","Cancel")
			switch(class)
				if("Icon")
					var/econ = input("Pick icon:","Icon") as icon
					usr.faceicon = econ
				if("Preset Icon")
					switch(input("What icon do you want to use?", "Icon Choose") in list ("Goku","Gohan","Vegeta","Trunks","Goten","Kami","Dende","Turles","Vegeta2","Frieza"))
						if("Goku")
							usr.faceicon = 'goku.bmp'
						if("Vegeta")
							usr.faceicon = 'vegeta.bmp'
						if("Gohan")
							usr.faceicon = 'gohan.bmp'
						if("Trunks")
							usr.faceicon = 'trunks.bmp'
						if("Dende")
							usr.faceicon = 'dende.bmp'
						if("Goten")
							usr.faceicon = 'goten.bmp'
						if("Kami")
							usr.faceicon = 'kame.bmp'
						if("Raditz")
							usr.faceicon = 'raditz.bmp'
						if("Turles")
							usr.faceicon = 'turles.bmp'
						if("Vegeta2")
							usr.faceicon = 'vegeta2.bmp'
						if("Frieza")
							usr.faceicon = 'icer.bmp'
			for(var/obj/O in view(1,usr))
				if(O.name=="faceicondisplay")
					O.icon=usr.faceicon

mob
	proc
		sideselect()
			switch(alert("It is recommended you choose this after your Style or your Will, Purity, and Honor will be lost!","WARNING!!!","Continue","Cancel"))
				if("Continue")
					if(usr.chose == 1)
						usr << "You have chosen already."
					if(usr.chose == 0||usr.chose == null)
						usr.chose = 1
						switch(input("Good or Evil? (You can only choose this once! So make sure you pick what you want", "Character Creation", text) in list ("Good", "Evil"))
							if("Good")
								usr.alignment = "Good"
								usr.random = rand(1,1000)
								if(usr.random == 1000)
									if(usr.race == "Saiya-jin")
										world << "<b><font color = green>A new Super Saiya-jin has been born."
										usr.overlays = 0
										alert("Your character was born a Super Saiya-jin. Do not delete this character.")
										usr.punchstrength = 1000
										usr.kickstrength = 1000
										usr.defense=1000
										usr.powerlevel = 100000
										usr.maxpowerlevel = 100000
										usr.contents += new /obj/ssj
										usr.attribute = "Legendary Super Saiya-jin"
									else
										world << "<b><font color = green>A god has arrived."
										usr.punchstrength = 1000
										usr.kickstrength = 1000
										usr.defense=1000
										usr.powerlevel = 100000
										usr.maxpowerlevel = 100000
										alert("Your character was born a legend. Do not delete this character.")
										usr.attribute = "Legend"

								if(usr.random < 999 && usr.random >= 899)

									alert("Elite: You are superiorly strong. You were born in an Elite Family, which gives you advantage. But you will gain will and honor slower.")
									usr.maxpowerlevel += rand(1,1000)
									usr.purity -= rand(1,2)
									usr.honor -= rand(1,2)
									usr.will -= rand(1,2)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Elite Warrior"
								if(usr.random < 898 && usr.random >= 700)

									alert("High-Class Warrior: You are a high-class warrior.You have excellent strength, but you are extremely weak in Ki.")
									usr.maxpowerlevel += rand(1,105)
									usr.powerlevel = usr.maxpowerlevel
									usr.purity += 1
									usr.honor += 1
									usr.will += 1
									usr.attribute = "High-Class Warrior"
								if(usr.random < 699 && usr.random >= 400)
									alert("Medium-Class Warrior: You are a medium-class warrior.You are equal in both Ki and Strength.")
									usr.maxpowerlevel += rand(1,30)
									usr.purity += rand(1,2)
									usr.honor += rand(1,2)
									usr.will += rand(1,2)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Medium-Class Warrior"
								if(usr.random < 399 && usr.random >= 100)
									alert("Low-Class Warrior: You are a low-class warrior. You are weak at start, but will become stronger than most. You have good Will, Honor, and Purity.")
									usr.maxpowerlevel += rand(1,5)
									usr.purity += rand(3,5)
									usr.honor += rand(3,5)
									usr.will += rand(3,5)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Low-Class Warrior"
								if(usr.random < 99 && usr.random >= 1)
									alert("Peasant Warrior: You are a peasant warrior. You are very weak at start, but will become stronger than most. You have awesome Will, Honor, and Purity. The legendary Kakarotto was this.")
									usr.purity += rand(5,10)
									usr.honor += rand(5,10)
									usr.will += rand(5,10)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Peasant Warrior"


							if("Evil")
								usr.alignment = "Evil"
								usr.random = rand(1,1000)
								if(usr.random == 1000)
									if(usr.race == "Saiya-jin")
										world << "<b><font color = green>A new Super Saiya-jin has been born."
										usr.overlays = 0
										alert("Your character was born a Super Saiya-jin. Do not delete this character.")
										usr.punchstrength = 1000
										usr.kickstrength = 1000
										usr.defense=1000
										usr.powerlevel = 100000
										usr.maxpowerlevel = 100000
										usr.contents += new /obj/ssj
										usr.attribute = "Legendary Super Saiya-jin"
									else
										world << "<b><font color = green>The eternal darkness has arrived."
										usr.punchstrength = 1000
										usr.kickstrength = 1000
										usr.defense=1000
										usr.powerlevel = 100000
										usr.maxpowerlevel = 100000
										alert("Your character was born a legend. Do not delete this character.")
										usr.attribute = "Legend"
								if(usr.random < 999 && usr.random >= 899)

									alert("Elite: You are superiorly strong. You were born in an Elite Family, which gives you advantage. But you will gain will and honor slower.")
									usr.maxpowerlevel += rand(1,1000)
									usr.purity -= rand(1,2)
									usr.honor -= rand(1,2)
									usr.will -= rand(1,2)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Elite Warrior"
								if(usr.random < 898 && usr.random >= 700)

									alert("High-Class Warrior: You are a high-class warrior.You have excellent strength, but you are extremely weak in Ki.")
									usr.maxpowerlevel += rand(1,25)
									usr.powerlevel = usr.maxpowerlevel
									usr.purity += 1
									usr.honor += 1
									usr.will += 1
									usr.attribute = "High-Class Warrior"
								if(usr.random < 699 && usr.random >= 400)
									alert("Medium-Class Warrior: You are a medium-class warrior.You are equal in both Ki and Strength.")
									usr.maxpowerlevel += rand(1,10)
									usr.purity += rand(1,2)
									usr.honor += rand(1,2)
									usr.will += rand(1,2)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Medium-Class Warrior"
								if(usr.random < 399 && usr.random >= 100)
									alert("Low-Class Warrior: You are a low-class warrior. You are weak at start, but will become stronger than most. You have good Will, Honor, and Purity.")
									usr.maxpowerlevel += rand(1,5)
									usr.purity += rand(3,5)
									usr.honor += rand(3,5)
									usr.will += rand(3,5)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Low-Class Warrior"
								if(usr.random < 99 && usr.random >= 1)
									alert("Peasant Warrior: You are a peasant warrior. You are very weak at start, but will become stronger than most. You have awesome Will, Honor, and Purity. The legendary Kakarotto was this.")
									usr.purity += rand(5,10)
									usr.honor += rand(5,10)
									usr.will += rand(5,10)
									usr.powerlevel = usr.maxpowerlevel
									usr.attribute = "Peasant Warrior"
						usr.chose = 1
						usr.npp = 0