client
	script = "<STYLE>BODY {background: black; color: white} BIG IMG.icon {width: 24px; height: 24px}</STYLE>"

world
	hub = "DemonProductions.DragonballZFightForPower "
	view = 6
	tick_lag = 2
	loop_checks = 0
	turf=/turf/grass
	name="Dragonball Z Fight For Power"
	status=" Early Beta"

world/New()
	OpenPort(0)

client
	verb
		Save()
			set category = "Communication"
			usr << "Saving Character..."
			SaveMob()

mob/proc/levelcheck()
	if(usr.exp>=100)
		usr.exp=0
		usr.level+=1
		var/powerlevelplus=(rand(3,5)*rand(45,50)*usr.level)
		var/punchstrengthplus=(rand(35,40)*usr.level)
		var/kickstrengthplus=(rand(35,40)*usr.level)
		var/defenseplus=(rand(35,40)*usr.level)
		var/zenniplus=(10*usr.level+rand(1,15))
		usr.zenni+=zenniplus
		usr.punchstrength+=punchstrengthplus
		usr.kickstrength+=kickstrengthplus
		usr.defense+=defenseplus
		usr.maxpowerlevel+=powerlevelplus
		usr<<"<center>----------"
		usr<<"<center><b><font color=green>Level Up!"
		usr<<"<center><b><font color=green>Power Level + [powerlevelplus]"
		usr<<"<center><b><font color=green>Punch Strength + [punchstrengthplus]"
		usr<<"<center><b><font color=green>Kick Strength + [kickstrengthplus]"
		usr<<"<center><b><font color=green>Defense + [defenseplus]"
		usr<<"<center><b><font color=green>Zenni + [zenniplus]"
		usr.FlightLearn()
		usr.AuraTechLearn()
		usr.KiTechLearn()
		usr.FocusLearn()
		usr.AuraMake()
		usr<<"<center>----------</center>"

//Hair
obj
	ki
		icon = 'skills.dmi'
		icon_state = "ki"
		layer = MOB_LAYER + 99
obj
	kihit
		icon = 'skills.dmi'
		icon_state = "kihit"
		layer = MOB_LAYER + 99


var/help = {"
<html>
<head><title>Game Manual</title></head><body>
<body bgcolor="black" text="red">
<center><B><H1>DragonBall Z<br>Fight For Power<br>Help Page</H1></B><p><H3>
</center>

<h2><font color=white>Stats-<font color=red>
<h3>Leveling-
<h4>Gaining levels will allow you to learn new skills and increase all your stats, the higher your level the more each stat will increase
<h3>Exp-
<h4>When this reaches 100% youll gain a level!
<h3>Power Level-
<h4>This is your energy! if it runs out you die!<br>
Your Power Level determines how much energy you can put into your special attack, Put too much and kapow!<br>
This can be recharged by powering up or by eating senzu beans
<h3>Punch & Kick-
<h4>These determine how much damage your punches and kicks will do
<h3>Block-
<h4>This number is subtracted from enemy attacks when your blocking
<h3>Will, Honor, Purity-
<h4>Certain levels of these 3 stats are required to learn certain moves
<h3>Zenni-
<h4>How much money you have

<h2><font color=white>Training-<font color=blue><br>
<h3>Killing Enemies-<h4> This is self explanatory and the fastest way to train
<h3>Speed Bags-<h4> Training on these will give you exp each time you attack them
<h3>Training Dummies-<h4> Slower exp gain then speed bags but the attacking continues automaticaly
<h3>Shadow Sparring-<h4> About the same exp gain as training dummies but this technique can be used anywhere
<h3>Meditating-<h4> Gaining exp this way is extremely slow but meditating slightly increases your stats without leveling
<h3>Gravity-<h4> Gravity training doesnt give you exp, it just boosts your power level<p>
<h3>Budokias-<h4> If a GM starts a budokia, to join it talk to hercule,near the spawn point,he will tech you how to join budokia.<p>
<h3>Trunks-<h4> Trunks is located in a gravity training center. To get there go into the door on the right hand side of the main gym enterance (or right of spawn point) <p>

<h2><font color=white>The Transformations List can be viewed in your Byond browser<font color=blue><br>
<center>
</body></html>"}
var/const/trans = {"
<html>
<head><title>Transformations</title></head><body>
<body bgcolor="black" text="blue">
<center><B><H1>DragonBall Z<br>Fight For Power<br>Transformations</H1></B><p><H3>
-Saiyans-<br>
~Super Saiyan~<br>
--Enrage + 300,000 PL--<br>
~Ultra Super Saiyan~<br>
--Transform + 600,000 PL--<br>
~Super Saiyan 2~<br>
--Transform + 1,000,000 PL--<br>
~Super Saiyan 3~<br>
--Transform + 5,000,000 PL--<br>
~Super Saiyan 4~<br>
--Transform + 10,000,000 PL--<p>

-Android-<br>
~Super Android~<br>
--Transform + 10 chips + 300,000 PL--<p>

-Icer-<br>
~Form 2~<br>
--Transform + 100,000 PL--<br>
~Form 3~<br>
--Transform + 500,000 PL--<br>
~Form 4~<br>
--Transform + 1,000,000 PL--<p>

-Bio-Android (Cell Type)-<br>
~Form 2~<br>
--Transform + 500,000 PL--<br>
~Form 3~<br>
--Transform + 2,500,000 PL--<p>

-Demon-<br>
~Form 2~<br>
--Transform + 300,000--<br>
~Form 3~<br>
--Transform + 400,000 PL--<br>
~Form 4~<br>
--Transform + 2,000,000 PL--<br>
~Form 5~<br>
--Transform + 3,000,000 PL--<p>

-Note: for Demons To Get Transform Talk to Janemba Outside of the gym near spawn when your at 300,000 pl or higher-<p>

All races will have at least 1 transformation I just havent finished adding them yet
</body></html>}

Trunks is located in a gravity training center. To get there go into the door on the right hand side of the main gym enterance (or right of spawn point)
</body></html>}

Note: GMs To enter GM Area You must First Give yourself PERM GM lvl 2 or the Admin door (left side of spawn point) will not let you through
</body></html>"}

mob/verb/Taunt()
	set category="Communication"
	if(usr.talk==1)
		switch(input("Which taunt do you wish to use?","Taunt")in list("...Your Too Weak","...You Wont Escape My Wrath!!!","Enough for ya...","...Your Face","Laugh","None"))
			if("...Your Too Weak")
				view()<<sound('WEAK.wav')
				view()<<"[usr]: Youll never succeed, your too weak"
			if("...You Wont Escape My Wrath!!!")
				view()<<"[usr]: Ill get you for this! You wont escape... MY WRATH!"
				view()<<sound('wrath.wav')
			if("Enough for ya...")
				view()<<"[usr]: Was that enough for ya? Huh? You want some more?"
				view()<<sound('enough.wav')
			if("...Your Face")
				view()<<"[usr]: Oh, I thought that was your face"
				view()<<sound('face.wav')
			if("Laugh")
				view()<<"*[usr] laughs*"
				view()<<sound('laugh.wav')
	else
		usr<<"You have been muted!"